%!TEX root=../../source.tex
%!TEX file=animations/frenetserret/torusknot.tex


\pgfplotstableread[%
    col sep=comma,%
  ]{animations/frenetserret/torusknot/curve.dat}\curvetable
\pgfplotstableread[%
    col sep=comma,%
  ]{animations/frenetserret/torusknot/measures.dat}\measuretable

\begin{animateinline}[loop,poster=first,controls]{15}
  \multiframe{314}{ix=0+1}{
  % \multiframe{15}{ix=0+1}{
    \pgfplotstableread[%
        col sep=comma,%
      ]{animations/frenetserret/torusknot/frame_\ix/tnb.dat}\tnbtable
    
    \begin{tikzpicture}
      \begin{groupplot}[%
          group style={%
            % Layout
            columns=1,%
            rows=2,%
            horizontal sep=0.00em,%
            vertical sep=3.00\baselineskip,%
          },%
        ]
        
        \nextgroupplot[%
            % General adjustments
            line plot 3d,%
            cycle list name=/ustutt/linestyles*,%
            % cycle multiindex* list={%
            %   /ustutt/linestyles*\nextlist%
            %   /ustutt/color list%
            % },%
            view={10}{10},%
            % width=1.00\linewidth,%
            height=0.50\textheight,%
            axis equal,%
            %
            % X-Axis
            xmin=-1.50,%
            xmax=1.50,%
            xticklabels={},%
            %
            % Y-Axis
            ymin=-1.50,%
            ymax=1.50,%
            yticklabels={},%
            %
            % Z-Axis
            zmin=-0.55,%
            zmax=1.25,%
            zticklabels={},%
            %
            % Legend
            legend style={%
              at={(0.50,1.05)},%
              anchor=south,%
              legend columns=2,%
              transpose legend,%
            },%
          ]%
        \addplot3+[%
            /ustutt/thin,%
            no markers,%
            % mark repeat=689,%
            % mark phase=0,%
          ]table[%
            x=x,%
            y=y,%
            z=z,%
          ]%
          {\curvetable};
        \addlegendentry{Curve $\curve \of{\pathcoord}$};
        
        % Tangent
        \addplot3+[%
            /ustutt/thin,%
            no markers,%
            draw=Red,%
            ->,%
            solid,%
            quiver={%
              u=\thisrow{u},%
              v=\thisrow{v},%
              w=\thisrow{w},%
            },%
          ]table[%
            x=x,%
            y=y,%
            z=z,%
            select coords between index={0}{1},%
          ]{\tnbtable};
        \addlegendentry{Tangent $\tangent \of{\pathcoord}$};
        
        % Normal
        \addplot3+[%
            /ustutt/thin,%
            no markers,%
            draw=Green,%
            ->,%
            solid,%
            quiver={%
              u=\thisrow{u},%
              v=\thisrow{v},%
              w=\thisrow{w},%
            },%
          ]table[%
            x=x,%
            y=y,%
            z=z,%
            select coords between index={1}{2},%
          ]{\tnbtable};
        \addlegendentry{Normal $\normal \of{\pathcoord}$};
        
        % Binormal
        \addplot3+[%
            /ustutt/thin,%
            no markers,%
            draw=Blue,%
            ->,%
            solid,%
            quiver={%
              u=\thisrow{u},%
              v=\thisrow{v},%
              w=\thisrow{w},%
            },%
          ]table[%
            x=x,%
            y=y,%
            z=z,%
            select coords between index={2}{3},%
          ]{\tnbtable};
        \addlegendentry{Binormal $\binormal \of{\pathcoord}$};
        
        \nextgroupplot[%
            % General adjustments
            line plot,%
            tufte-like,%
            width=1.00\linewidth,%
            height=0.30\textheight,%
            %
            % X-Axis
            xmin=0.00,%
            xmax=1.00,%
            xlabel={Path coordinate $\pathcoord / \parentheses{}$},
            xlabel near ticks,%
            %
            % Y-Axis
            ymin=-1.00,%
            ymax=3.50,%
            ylabel={Measure},%
            ylabel near ticks,%
            %
            % Legend
            legend style={%
              at={(0.50,1.05)},%
              anchor=south,%
              legend columns=-1,%
            },%
          ]
        
        \addplot+[%
            no markers,%
            /ustutt/thin,%
            draw=Red!80,%
          ] table [%
              x=xi,%
              y=cur,%
              select coords between index={0}{\ix},%
            ]{\measuretable};
        \addlegendentry{$\curvature$};
        
        \addplot+[%
            no markers,%
            /ustutt/thin,%
            draw=Blue!80,%
          ] table [%
              x=xi,%
              y=tor,%
              select coords between index={0}{\ix},%
            ]{\measuretable};
        \addlegendentry{$\torsion$};
      \end{groupplot}
    \end{tikzpicture}
  }
\end{animateinline}
